import Component from '@glimmer/component';
interface DropdownToggleSignature {
    Element: HTMLDivElement;
    Args: {
        inNav?: boolean;
        isOpen?: boolean;
        onClick?: () => void;
        onKeyDown: (event: KeyboardEvent) => void;
    };
    Blocks: {
        default: [];
    };
}
/**
 Anchor element that triggers the parent dropdown to open.
 Use [Components.DropdownButton](Components.DropdownButton.html) if you want a button instead of an anchor tag.

 See [Components.Dropdown](Components.Dropdown.html) for examples.

 @class DropdownToggle
 @namespace Components
 @extends Component
 @publicø
 */
export default class DropdownToggle extends Component<DropdownToggleSignature> {
    /**
     * @property inNav
     * @type {boolean}
     * @private
     */
    get inNav(): boolean;
    get 'aria-expanded'(): "false" | "true";
    /**
     * When clicking the toggle this action is called.
     *
     * @event onClick
     * @param {*} value
     * @public
     */
    handleClick(e: MouseEvent): void;
    handleKeyDown(e: KeyboardEvent): void;
}
export {};
//# sourceMappingURL=toggle.d.ts.map